Thread (1 message) 1 message, 1 author, 2016-06-15

Fwd: [MinGW port] Unable to repack on Clearcase dynamic views

From: Nguyen Thai Ngoc Duy <hidden>
Date: 2016-06-15 22:43:13

I'm sorry, forgot to CC the list.

---------- Forwarded message ----------
From: Nguyen Thai Ngoc Duy <redacted>
Date: May 30, 2007 11:40 AM
Subject: Re: [MinGW port] Unable to repack on Clearcase dynamic views
To: Johannes Sixt <redacted>


On 5/30/07, Johannes Sixt [off-list ref] wrote:
Nguyen Thai Ngoc Duy wrote:
quoted
On clearcase dynamic views (kind of virtual drives), "mv -f a b" won't
work if "a" is read-only. Because git-repack.sh removes all write
permission before moving packs, it fails on clearcase dynamic views.

My approach is rather ugly. Does anyone have a better solution?
If you do two 'git repack -a -d' in a row, the second one fails even
with this patch, right? To fix it, you must 'chmod u+w' in the for-loop
right above this hunk, too.
Well, I'm not sure I understand it. git-repack with the patch applied
runs fine for me. Can you explain it more detail please?
Since you 'chmod a-w' after the mv, why not just remove the first ones
before the first mv? Then you can get rid of the second try.
Because I'm not sure what that command is for :) I suspect that packs
(or anything inside .git/objects) are read-only and the author want to
make sure no one can write to the packs as soon as they are created.
The other way to do is to move 'chmod a-w' down several lines -- we
only make those files read-only after moving them to
.git/objects/packs.
-- Hannes
quoted
diff --git a/git-repack.sh b/git-repack.sh
index acb78ba..76a9525 100755
--- a/git-repack.sh
+++ b/git-repack.sh
@@ -86,10 +86,22 @@ else
        mv -f "$PACKTMP-$name.idx"  "$PACKDIR/pack-$name.idx" &&
        test -f "$PACKDIR/pack-$name.pack" &&
        test -f "$PACKDIR/pack-$name.idx" || {
-               echo >&2 "Couldn't replace the existing pack with updated one."
-               echo >&2 "The original set of packs have been saved as"
-               echo >&2 "old-pack-$name.{pack,idx} in $PACKDIR."
-               exit 1
+               # Clearcase dynamic views do not allow to move file without write permission
+               # Try the second time with write allowed
+               chmod u+w "$PACKTMP-$name.pack"
+               chmod u+w "$PACKTMP-$name.idx"
+
+               mv -f "$PACKTMP-$name.pack" "$PACKDIR/pack-$name.pack" &&
+               mv -f "$PACKTMP-$name.idx"  "$PACKDIR/pack-$name.idx" &&
+               test -f "$PACKDIR/pack-$name.pack" &&
+               test -f "$PACKDIR/pack-$name.idx" || {
+                       echo >&2 "Couldn't replace the existing pack with updated one."
+                       echo >&2 "The original set of packs have been saved as"
+                       echo >&2 "old-pack-$name.{pack,idx} in $PACKDIR."
+                       exit 1
+               }
+               chmod a-w "$PACKDIR/pack-$name.pack"
+               chmod a-w "$PACKDIR/pack-$name.idx"
        }
        rm -f "$PACKDIR/old-pack-$name.pack" "$PACKDIR/old-pack-$name.idx"
 fi

--
Duy

--
Duy


-- 
Duy
Keyboard shortcuts
hback out one level
jnext message in thread
kprevious message in thread
ldrill in
Escclose help / fold thread tree
?toggle this help